"use strict";

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.regexp.replace");

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _helperPluginUtils = require("@babel/helper-plugin-utils");

var _core = require("@babel/core");

var _outputFileSync = _interopRequireDefault(require("output-file-sync"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = (0, _helperPluginUtils.declare)(function (_ref, _ref2) {
  var assertVersion = _ref.assertVersion;
  var _ref2$dir = _ref2.dir,
      dir = _ref2$dir === void 0 ? './lib' : _ref2$dir,
      _ref2$relativeRoot = _ref2.relativeRoot,
      relativeRoot = _ref2$relativeRoot === void 0 ? './src' : _ref2$relativeRoot,
      _ref2$presets = _ref2.presets,
      presets = _ref2$presets === void 0 ? [] : _ref2$presets,
      _ref2$plugins = _ref2.plugins,
      plugins = _ref2$plugins === void 0 ? [] : _ref2$plugins,
      _ref2$verbose = _ref2.verbose,
      verbose = _ref2$verbose === void 0 ? true : _ref2$verbose,
      ignore = _ref2.ignore;
  assertVersion(7);
  return {
    post: function post(_ref3) {
      var _ref3$opts = _ref3.opts,
          cwd = _ref3$opts.cwd,
          filename = _ref3$opts.filename,
          parserOpts = _ref3$opts.parserOpts,
          content = _ref3.code;
      // $FlowFixMe Flow does not yet support method or property calls in optional chains.
      if (ignore === null || ignore === void 0 ? void 0 : ignore.test(filename)) return;
      var _console = console,
          log = _console.log;
      var filePath = "".concat(_path["default"].resolve(cwd, dir, _path["default"].relative(_path["default"].resolve(cwd, relativeRoot), filename)), ".flow");
      var output = _fs["default"].existsSync("".concat(filename, ".flow")) ? _fs["default"].readFileSync("".concat(filename, ".flow"), 'utf-8') : (0, _core.transformSync)(content, {
        filename: filename,
        parserOpts: parserOpts,
        presets: presets,
        plugins: plugins,
        babelrc: false,
        configFile: false
      }).code;
      (0, _outputFileSync["default"])(filePath, output.replace(/fixme-flow-file-annotation/, '@flow'));
      if (verbose) log("".concat(_path["default"].relative(cwd, filename), " -> ").concat(_path["default"].relative(cwd, filePath)));
    }
  };
});

exports["default"] = _default;
module.exports = exports.default;